#!/bin/bash

PATH=$PATH:$HOME/bin

set -e

cd $(dirname $0)

mkdir -p logs

NOW=$(date +%F_%R:%S)
LOG=${NOW}.log

if ! make -C steps > logs/$LOG 2>&1; then
       cat logs/$LOG
       exit 1
fi

make -C www --silent publish

( cd logs && git add $LOG && git commit --quiet -m 'Automatic commit' && git push --quiet )
